.\" $NetBSD: ses.4,v 1.7 2009/04/10 13:30:11 joerg Exp $
.\" Copyright (c) 2001 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Matthew Jacob.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.\"
.Dd May 24, 2007
.Dt SES 4
.Os
.Sh NAME
.Nm ses
.Nd SCSI Environmental Services Driver
.Sh SYNOPSIS
.Cd ses* at scsibus? target ? lun ?
.Sh DESCRIPTION
The
.Nm ses
driver provides support for all
.Tn SCSI
devices of the environmental services class that are attached to the system
through a supported
.Tn SCSI
Host Adapter, as well as emulated support for SAF-TE (SCSI Accessible
Fault Tolerant Enclosures).
The environmental services class generally are enclosure devices that
provide environmental information such as number of power supplies (and
state), temperature, device slots, and so on.
.Pp
A
.Tn SCSI
Host
adapter must also be separately configured into the system
before a
.Tn SCSI
Environmental Services device can be configured.
.Sh IOCTLS
The following
.Xr ioctl 2
calls apply to
.Em SES
devices.
They are defined in the header file
.Aq Pa scsipi/ses.h
(q.v.).
.Pp
.Bl -tag -width SESIOC_GETENCSTAT
.It Dv SESIOC_GETNOBJ
Used to find out how many
.Em SES
objects are driven by this particular device instance.
.It Dv SESIOC_GETOBJMAP
Read, from the kernel, an array of SES objects which contains
the object identifier, which sub-enclosure it is in, and the
.Em SES
type of the object.
.It Dv SESIOC_GETENCSTAT
Get the overall enclosure status.
.It Dv SESIOC_SETENCSTAT
Set the overall enclosure status.
.It Dv SESIOC_GETOBJSTAT
Get the status of a particular object.
.It Dv SESIOC_SETOBJSTAT
Set the status of a particular object.
.It Dv SESIOC_GETTEXT
Get the associated help text for an object (not yet implemented).
.Em SES
devices often have descriptive text for an object which can tell
you things like location (e.g, "left power supply").
.It Dv SESIOC_INIT
Initialize the enclosure.
.El
.Sh FILES
.Bl -tag -width /dev/rsdXXXXX -compact
.It Pa /dev/ses Ns Ar N
The
.Em Nth
.Nm
device.
.El
.Sh DIAGNOSTICS
When the kernel is configured with
.Tn DEBUG
enabled, the first open to an SES device will spit out overall enclosure
parameters to the console.
.Sh SEE ALSO
.Xr getencstat 8 ,
.Xr sesd 8 ,
.Xr setencstat 8 ,
.Xr setobjstat 8
.Sh HISTORY
The
.Nm
driver was written for the
.Tn SCSI
subsystem by Matthew Jacob.
This is the functional equivalent of a similar
driver available in Solaris, Release 7.
